unit Unit1;
{find way to preserve aspect ratio
 F. J. Rohlf, 15 Oct. 2015}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, TeeComma, ExtCtrls, TeeProcs, TeEngine, Chart,
  StdCtrls;

type
  TForm1 = class(TForm)
    TeeCommander1: TTeeCommander;
    Panel1: TPanel;
    Chart1: TChart;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RecalculateSizes(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  started: boolean;

implementation

{$R *.dfm}

uses Series, TeCanvas, Math;

var
  dataaspect: double;
  ChartMarginsH, ChartMarginsW, AW, AH: integer;

procedure TForm1.FormCreate(Sender: TObject);
var
  i: integer;
  RangeX, RangeY: double;
begin
  Panel1.Align := alNone;
  Chart1.ClearChart;
  Chart1.AddSeries(TLineSeries.Create(Self));
  for i := 0 to 10 do
    Chart1[0].AddXY(i / 10, i / 20);

  with Chart1 do begin
    View3D := False;
    Title.Caption := 'title';
    LeftAxis.Title.Caption := 'Y';
    BottomAxis.Title.Caption := 'X';
    Axes.Left.Automatic := true;
    Axes.Bottom.Automatic := true;
    Axes.Left.Increment := 0.1;
    Axes.Bottom.Increment := 0.1;
    RangeX := Series[0].MaxXValue - Series[0].MinXValue;
    RangeY := Series[0].MaxYValue - Series[0].MinYValue;
    dataaspect := RangeY / RangeX;
    Draw;
  end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  RecalculateSizes(Sender);
end;

procedure TForm1.RecalculateSizes(Sender: TObject);
var
  axesaspect, AvailableAspect: double;
  TopBarHeight, AvailableH: integer;
begin
  { available area for chart }
  TopBarHeight := Height - ClientHeight;
  AvailableH := ClientHeight - TopBarHeight;
  AvailableAspect := AvailableH / ClientWidth;
  if Chart1.Height > 0 then begin { avoid /0 }
    { compute aspect ratio for chart and for panel }
    ChartMarginsH := Chart1.Height - Chart1.ChartHeight;
    ChartMarginsW := Chart1.width - Chart1.ChartWidth;
    AW := Panel1.width - ChartMarginsW;
    AH := round(AW * dataaspect);
    if AW > 0 then
      axesaspect := AH / AW
    else
      axesaspect := 1;
    { fill panel but keep aspect ratio }
    if AvailableAspect >= dataaspect then begin { window too tall }
      Panel1.width := ClientWidth;
      Panel1.Height := round((width - ChartMarginsW) * axesaspect +
        ChartMarginsH);
    end else begin { window too wide }
      Panel1.Height := ClientHeight - TeeCommander1.Height;
      Panel1.width := round((Panel1.Height - ChartMarginsH) / axesaspect +
        ChartMarginsW);
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Chart1.Legend.Visible := not Chart1.Legend.Visible; { toggle legend }
  FormResize(Sender);
end;

end.
